#include "assembler.h"
#include <unistd.h>
#include <string.h>
#include <stdio.h>

static char msg[100];

void printmemref(memory_ref_t ref) {
  int flag = 0;

  switch(GET_MODE(ref.type)) {
  case CONSTANT:
    /*
    if (GET_TYPE(ref.type)==CODE_SECTION)
      break;
    */
    strcat(msg,"#");
    flag=1;
    break;
  case DIRECT:
    break;
  case INDIRECT:
    strcat(msg,"*");
    break;
  }
  sprintf(msg+strlen(msg),"%d",ref.addr);
}

void printonearg(instruction_t ins) {
  printmemref(ins.datas.onearg.arg);
}

void printtwoargs(instruction_t ins) {
  printmemref(ins.datas.twoargs.arg1);
  strcat(msg,",");
  printmemref(ins.datas.twoargs.arg2);
}

void printif(instruction_t ins) {
  printmemref(ins.datas.si.arg1);
  strcat(msg,",");
  printmemref(ins.datas.si.arg2);
  strcat(msg,",");
  printmemref(ins.datas.si.arg3);
}

void printret(instruction_t ins) {
}

int main() {
  int           i = 0;
  instruction_t ins;

  while ( read(0,&ins,sizeof(instruction_t))==sizeof(instruction_t) ) {
    if (ins.opcode>LAST_OPCODE)
      sprintf(msg,"C%-4d:UNK     ",i++);
    else
      sprintf(msg,"C%-4d:%-8s",i++,opcodes[ins.opcode]);
    switch(ins.opcode) {
    case ASSIGN_PLUS:
    case ASSIGN_MINUS:
    case ASSIGN_MULT:
    case ASSIGN:
    case WAIT:
    case SIGNAL:
      printtwoargs(ins);
      break;
    case IF:
      printif(ins);
      break;
    case RET:
      printret(ins);
      break;
    case EXEC:
    case EXIT:
    case FORK:
    case READ:
    case WRITE:
    case KILL:
    case CALL:
    case GETPPID:
    case JUMP:
    case LCK:
    case UNLCK:
    case SETPRIO:
      printonearg(ins);
      break;
    }
    printf("%s\n",msg);
  }
  return 0;
}
